<?php
namespace Privy\Config;

/**
 * Privy.com Zen Cart Plugin
 * Copyright (C) 2015 Privy.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

use Privy\ORM\Model;

class Group extends Model {
    protected static $TABLE_NAME    = TABLE_CONFIGURATION_GROUP;
    protected static $COLUMN_PREFIX = "configuration_group";
    protected static $COLUMN_NAMES  = array();

    static function init() {
        static::$COLUMN_NAMES = array(
            static::c("id"),
            static::c("title"),
            static::c("description"),
            "sort_order",
            "visible"
        );
    }

    static function defaultProperties() {
        return array(
            static::c("title") => \Privy\TITLE,
            static::c("description") => "Set " . \Privy\TITLE . " Options",
            "sort_order" => '1',
            "visible" => '1'
        );
    }

    static function find() {
        return static::findWhere("configuration_group_title = '" . \Privy\TITLE . "'");
    }
}