<?php
namespace Privy\Config;

/**
 * Privy.com Zen Cart Plugin
 * Copyright (C) 2015 Privy.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

use Privy\ORM\Model;

class Item extends Model {
    protected static $TABLE_NAME    = TABLE_CONFIGURATION;
    protected static $COLUMN_PREFIX = "configuration";
    protected static $COLUMN_NAMES  = array();

    static function init() {
        static::$COLUMN_NAMES = array(
            static::c("id"),
            static::c("key"),
            static::c("title"),
            static::c("description"),
            static::c("group_id"),
            "sort_order",
            "last_modified",
            "date_added",
            "use_function",
            "set_function"
        );
    }

    static function defaultProperties() {
        return array();
    }

    /**
     * @param groupId - the id of the configuration group.
     * @param setting - the setting to find
     * @return Item
     */
    static function find() {
        $setting = func_get_arg(0);
        $groupId = func_get_arg(1);

        $key = $setting->getProperty("key");

        return static::findWhere(static::c("key") . " = '$key' AND " . static::c("group_id") . " = '$groupId'");
    }
}