<?php
namespace Privy;

/**
 * Privy.com Zen Cart Plugin
 * Copyright (C) 2015 Privy.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

use Privy\Config\Group;
use Privy\Config\Item;

class Installer {
    static function defaultSettings() {
        return array(
            Item::build(array(
                "title" => "Business Identifier",
                "key" =>  \Privy\PREFIX . "_BUSINESS_IDENTIFIER",
                "description" => "Your " . \Privy\TITLE . " Business Identifier"
            ))
        );
    }

    function initialize() {
        Group::init();
        Item::init();
    }

    function setup() {
        global $messageStack;

        $this->initialize();

        $group = Group::findOrCreate();
        $groupId = $group->getProperty("id");

        foreach (static::defaultSettings() as $setting) {
            $setting->setProperties(array("group_id" => $groupId));
            $setting->findOrCreate($setting, $groupId);
        }

        if (!zen_page_key_exists(\Privy\PAGE_KEY)) {
            zen_register_admin_page(
                \Privy\PAGE_KEY,
                'BOX_CONFIGURATION_PRIVY',
                'FILENAME_CONFIGURATION',
                "gID=" . $groupId,
                'configuration',
                'Y',
                $groupId
            );

            $messageStack->add("Installed Privy.com Plugin (v" . \Privy\VERSION . ")", "success");
        }
    }
}