<?php
namespace Privy\Utils;

/**
 * Privy.com Zen Cart Plugin
 * Copyright (C) 2015 Privy.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

/**
 * Joins values from two lists with a separator, delimiting each pair.
 *
 * @param lhs: list of strings
 * @param rhs: list of strings
 * @param sep: string - the separator
 * @param del: string - the delimiter
 *
 * @return string
 *
 * Example:
 *  echo join(array("a", "b"), array(1, 2), " = ", ", ");
 *  => "a = 1, b = 2"
 */
function join($lhs, $rhs, $sep, $del) {
    $joiner = function ($k, $v) use ($sep, $del) {
        return $k . $sep . $v . $del;
    };

    return array_map($joiner, $lhs, $rhs);
}